package client; 

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.reflect.CodeSignature;
import java.io.PrintWriter;
import java.util.*; 
import java.rmi.*;
import filter.ISearchFilterPipe;
import filter.Result ; 
import java.rmi.server.RemoteStub; 

aspect SearchAspect {

	ISearchFilterPipe seFP ; 
	String filterPipeLocation ="//144.16.111.95/";

// pointcut and around advise for every method is required

    pointcut searchCall(server.ISearch se, String str):
		 execution (public String search(String)) && 
		           target(se)  && args(str) && !within(server.ISearch) ; 

	String around(server.ISearch se,String str) throws 
				RemoteException: searchCall(se,str)
	{ 
	    boolean flag = true ; 	 
         Result  res= new Result()  ;
	    Object args[] = new Object[1] ; 
		
		args[0] =   str ; 
//		System.out.println(((RemoteStub)se).getRef().toString()+ "" ) ; 
			 if (seFP == null )
		
	    try{
			 seFP = (ISearchFilterPipe) Naming.lookup(filterPipeLocation + "SearchEngineFilterPipe") ; 	          
	     } catch (Exception e) {System.out.println("error looking up some server" + e);}

	
		
		
		flag = seFP.searchUp(se, args ,res);
		
		if ( flag )
			  res.setRetValue( proceed(se,(String)args[0]));
		
		 seFP.searchDown(res); 
		return (String)  res.retValue() ; 
	}
	
}


